VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   9120
   ClientLeft      =   120
   ClientTop       =   450
   ClientWidth     =   13395
   LinkTopic       =   "Form1"
   ScaleHeight     =   9120
   ScaleWidth      =   13395
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton Command5 
      Caption         =   "Write SVG direct to GDI+ Bitmap (LockBits)"
      Height          =   375
      Left            =   60
      TabIndex        =   4
      Top             =   1740
      Width           =   3495
   End
   Begin VB.CommandButton Command4 
      Caption         =   "Write SVG to ByteArray to GDI+ Bitmap"
      Height          =   375
      Left            =   60
      TabIndex        =   3
      Top             =   1320
      Width           =   3495
   End
   Begin VB.CommandButton Command3 
      Caption         =   "Write SVG to PNG-Stream to GDI+ Bitmap"
      Height          =   375
      Left            =   60
      TabIndex        =   2
      Top             =   900
      Width           =   3495
   End
   Begin VB.CommandButton Command2 
      Caption         =   "Save SVG with WIC && D2D as PNG-File"
      Height          =   375
      Left            =   60
      TabIndex        =   1
      Top             =   480
      Width           =   3495
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Draw SVG with WIC && D2D"
      Height          =   375
      Left            =   60
      TabIndex        =   0
      Top             =   60
      Width           =   3495
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' Basiert auf:
' https://stackoverflow.com/questions/48690038/draw-svg-graphic-with-sharpdx

' Luft erst ab dem "Windows 10 Creators Update"!!! -> ID2D1DeviceContext5

' ----==== Const ====----
Private Const S_OK As Long = &H0&
Private Const GdiPlusVersion As Long = 1&
Private Const GENERIC_READ As Long = &H80000000
Private Const GENERIC_WRITE As Long = &H40000000
Private Const WICBitmapLockRead As Long = &H1&
Private Const WICBitmapCacheOnDemand As Long = &H1&
Private Const WICBitmapEncoderNoCache As Long = &H2&
Private Const DXGI_FORMAT_B8G8R8A8_UNORM As Long = &H57&
Private Const D2D1_ALPHA_MODE_PREMULTIPLIED As Long = &H1&
Private Const IID_ID2D1Factory As String = "{06152247-6f50-465a-9245-118bfd3b6007}"
Private Const IID_ID2D1DeviceContext5 As String = "{7836d248-68cc-4df6-b9e8-de991bf62eb7}"
Private Const IID_IWICImagingFactory As String = "{ec5ec8a9-c395-4314-9c77-54d7a935ff70}"
Private Const CLSID_WICImagingFactory1 As String = "{cacaf262-9370-4615-a13b-9f5539da4c0a}"
Private Const GUID_ContainerFormatPng As String = "{1b7cfaf4-713f-473c-bbcd-6137425faeaf}"
Private Const GUID_WICPixelFormat32bppPBGRA As String = "{6fddc324-4e03-4bfe-b185-3d77768dc910}"

' ----==== Enums ====----
Private Enum vtb_Interfaces
    QueryInterface = 0                  'IUnknown
    Initialize = 3                      'WIC
    SetSize = 4                         'WIC
    GetStride = 4                       'WIC
    GetDataPointer = 5                  'WIC
    SetPixelFormat = 6                  'WIC
    CopyPixels = 7                      'WIC
    Lock_Bits = 8                       'WIC
    CreateEncoder = 8                   'WIC
    CreateNewFrame = 10                 'WIC
    WriteSource = 11                    'WIC
    Commit_Encoder = 11                 'WIC
    Commit_Frame = 12                   'WIC
    CreateWicBitmapRenderTarget = 13    'D2D
    CreateStream = 14                   'WIC
    CreateHwndRenderTarget = 14         'D2D
    InitializeFromIStream = 14          'WIC
    InitializeFromFilename = 15         'WIC
    CreateBitmap = 17                   'WIC
    Clear = 47                          'D2D
    BeginDraw = 48                      'D2D
    EndDraw = 49                        'D2D
    Resize = 58                         'D2D
    CreateSvgDocument = 115             'D2D
    DrawSvgDocument = 116               'D2D
End Enum

Private Enum ImageLockMode ' GDI+ LockMode
    ImageLockModeRead = &H1
    ImageLockModeWrite = &H2
    ImageLockModeUserInputBuf = &H4
End Enum

Private Enum Status ' GDI+ Status
    OK = 0
    GenericError = 1
    InvalidParameter = 2
    OutOfMemory = 3
    ObjectBusy = 4
    InsufficientBuffer = 5
    NotImplemented = 6
    Win32Error = 7
    WrongState = 8
    Aborted = 9
    FileNotFound = 10
    ValueOverflow = 11
    AccessDenied = 12
    UnknownImageFormat = 13
    FontFamilyNotFound = 14
    FontStyleNotFound = 15
    NotTrueTypeFont = 16
    UnsupportedGdiplusVersion = 17
    GdiplusNotInitialized = 18
    PropertyNotFound = 19
    PropertyNotSupported = 20
    ProfileNotFound = 21
End Enum

Private Enum PixelFormats ' GDI+ PixelFormats
    PixelFormatUndefined = &H0&
    PixelFormatDontCare = PixelFormatUndefined
    PixelFormatMax = &HF&
    PixelFormat1_8 = &H100&
    PixelFormat4_8 = &H400&
    PixelFormat8_8 = &H800&
    PixelFormat16_8 = &H1000&
    PixelFormat24_8 = &H1800&
    PixelFormat32_8 = &H2000&
    PixelFormat48_8 = &H3000&
    PixelFormat64_8 = &H4000&
    PixelFormat16bppRGB555 = &H21005
    PixelFormat16bppRGB565 = &H21006
    PixelFormat16bppGrayScale = &H101004
    PixelFormat16bppARGB1555 = &H61007
    PixelFormat24bppRGB = &H21808
    PixelFormat32bppRGB = &H22009
    PixelFormat32bppARGB = &H26200A
    PixelFormat32bppPARGB = &HD200B
    PixelFormat48bppRGB = &H10300C
    PixelFormat64bppARGB = &H34400D
    PixelFormat64bppPARGB = &H1C400E
    PixelFormatGDI = &H20000
    PixelFormat1bppIndexed = &H30101
    PixelFormat4bppIndexed = &H30402
    PixelFormat8bppIndexed = &H30803
    PixelFormatAlpha = &H40000
    PixelFormatIndexed = &H10000
    PixelFormatPAlpha = &H80000
    PixelFormatExtended = &H100000
    PixelFormatCanonical = &H200000
End Enum

' ----==== Types ====----
Private Type GUID
    data1 As Long
    data2 As Integer
    data3 As Integer
    data4(0 To 7) As Byte
End Type

Private Type RGBA
    r As Byte
    g As Byte
    b As Byte
    a As Byte
End Type

Private Type GDIPlusStartupInput
    GdiPlusVersion As Long
    DebugEventCallback As Long
    SuppressBackgroundThread As Long
    SuppressExternalCodecs As Long
End Type

Private Type GdiplusStartupOutput
    NotificationHook As Long
    NotificationUnhook As Long
End Type

Private Type BitmapData
    Width As Long
    Height As Long
    Stride As Long
    PixelFormat As Long
    Scan0 As Long
    ReservedPtr As Long
End Type

Private Type RECTL
    Left As Long
    Top As Long
    Width As Long
    Height As Long
End Type

Private Type WICRect
    x As Long
    y As Long
    Width As Long
    Height As Long
End Type

Private Type D2D1_SIZE_F
    Width As Single
    Height As Single
End Type

Private Type D2D1_COLOR_F
    r As Single
    g As Single
    b As Single
    a As Single
End Type

Private Type D2D1_PIXEL_FORMAT
    dFormat As Long
    alphaMode As Long
End Type

Private Type D2D1_SIZE_U
    Width As Long
    Height As Long
End Type

Private Type D2D1_RENDER_TARGET_PROPERTIES
    eType As Long
    PixelFormat As D2D1_PIXEL_FORMAT
    dpiX As Single
    dpiY As Single
    usage As Long
    minLevel As Long
End Type

Private Type D2D1_HWND_RENDER_TARGET_PROPERTIES
    hwnd As Long
    pixelSize As D2D1_SIZE_U
    presentOptions As Long
End Type

' ----==== Kernel32.dll API-Deklarationen ====----
Private Declare Sub CopyMemory Lib "Kernel32.dll" _
                    Alias "RtlMoveMemory" ( _
                    ByRef Destination As Any, _
                    ByRef Source As Any, _
                    ByVal length As Long)

' ----==== OLE32 API-Deklarationen ====----
Private Declare Function CLSIDFromString Lib "Ole32.dll" ( _
                         ByVal pstring As Long, _
                         ByRef pCLSID As GUID) As Long

' ----==== Oleaut32 API-Deklarationen ====----
Private Declare Function OleTranslateColor Lib "OleAut32.dll" ( _
                         ByVal lOleColor As Long, _
                         ByVal lHPalette As Long, _
                         ByRef lColorRef As Long) As Long

' ----==== Shlwapi API-Deklarationen ====----
Private Declare Function SHCreateMemStream Lib "Shlwapi.dll" ( _
                         ByVal pInit As Long, _
                         ByVal cbInit As Long) As Long

' ----==== D2D1.dll API-Deklarationen ====----
Private Declare Function D2D1CreateFactory Lib "D2D1.dll" ( _
                         ByVal factoryType As Long, _
                         ByVal riid As Long, _
                         ByVal pFactoryOptions As Long, _
                         ByRef ppIFactory As Long) As Long

' ----==== GDI+ API Declarationen ====----
Private Declare Function GdiplusShutdown Lib "GdiPlus.dll" ( _
                         ByVal token As Long) As Status
                         
Private Declare Function GdiplusStartup Lib "GdiPlus.dll" ( _
                         ByRef token As Long, _
                         ByRef lpInput As GDIPlusStartupInput, _
                         ByRef lpOutput As GdiplusStartupOutput) As Status

Private Declare Function GdipLoadImageFromStream Lib "GdiPlus.dll" ( _
                         ByVal mStream As Long, _
                         ByRef mImage As Long) As Status

Private Declare Function GdipCreateBitmapFromScan0 Lib "GdiPlus.dll" ( _
                         ByVal Width As Long, _
                         ByVal Height As Long, _
                         ByVal Stride As Long, _
                         ByVal Format As PixelFormats, _
                         ByVal Scan0 As Long, _
                         ByRef Bitmap As Long) As Status

Private Declare Function GdipBitmapLockBits Lib "GdiPlus.dll" ( _
                         ByVal mBitmap As Long, _
                         ByRef mRect As RECTL, _
                         ByVal mFlags As ImageLockMode, _
                         ByVal mPixelFormat As PixelFormats, _
                         ByRef mLockedBitmapData As BitmapData) As Status

Private Declare Function GdipBitmapUnlockBits Lib "GdiPlus.dll" ( _
                         ByVal mBitmap As Long, _
                         ByRef mLockedBitmapData As BitmapData) As Status

Private Declare Function GdipDisposeImage Lib "GdiPlus.dll" ( _
                         ByVal mImage As Long) As Status

' ----==== Variablen ====----
Private m_GdipToken As Long

Private Sub Form_Load()

    Dim tGdipSI As GDIPlusStartupInput
    Dim tGdipSO As GdiplusStartupOutput

    tGdipSI.GdiPlusVersion = GdiPlusVersion
    
    Call GdiplusStartup(m_GdipToken, tGdipSI, tGdipSO)

End Sub

Private Sub Form_Unload(Cancel As Integer)

    Call GdiplusShutdown(m_GdipToken)

End Sub

' SVG auf die Form rendern
Private Sub Command1_Click()

    Dim ptRTP As Long
    Dim ptHRTP As Long
    Dim ptGUID As Long
    Dim ptSIZEU As Long
    Dim ptCOLORF As Long
    Dim psFileName As Long
    Dim pWICStream As Long
    Dim ppWICStream As Long
    Dim pWicFactory As Long
    Dim pD2D1Factory As Long
    Dim pSvgDocument As Long
    Dim ppSvgDocument As Long
    Dim pRenderTarget As Long
    Dim ppRenderTarget As Long
    Dim pDeviceContext5 As Long
    Dim ppDeviceContext5 As Long
    Dim sFileName As String
    Dim tSIZEU As D2D1_SIZE_U
    Dim tSIZEF As D2D1_SIZE_F
    Dim tRTP As D2D1_RENDER_TARGET_PROPERTIES
    Dim tHRTP As D2D1_HWND_RENDER_TARGET_PROPERTIES
    
    ' muss Pixel sein!!!
    Me.ScaleMode = vbPixels
    
    ' Pfad zur SVG
    sFileName = App.Path & "\tiger.svg"
    
    ptGUID = VarPtr(Str2Guid(IID_ID2D1Factory))
    
    ' ein D2D1Factory Interface erstellen
    If D2D1CreateFactory(0&, ptGUID, 0&, pD2D1Factory) = S_OK Then
    
        ' Pixelformat und Alphamode fr den RenderTarget festlegen
        With tRTP
            .PixelFormat.dFormat = DXGI_FORMAT_B8G8R8A8_UNORM
            .PixelFormat.alphaMode = D2D1_ALPHA_MODE_PREMULTIPLIED
        End With
        
        ' Handle von dem ein RenderTarget erstellt werden soll
        With tHRTP
            .hwnd = Me.hwnd
        End With
        
        ptRTP = VarPtr(tRTP)
        ptHRTP = VarPtr(tHRTP)
        ppRenderTarget = VarPtr(pRenderTarget)
        
        ' ein D2D1HwndRenderTarget Interface erstellen
        If Invoke(pD2D1Factory, CreateHwndRenderTarget, ptRTP, ptHRTP, _
            ppRenderTarget) = S_OK Then
            
            ' Gre des RenderTargets
            With tSIZEU
                .Width = Me.ScaleWidth
                .Height = Me.ScaleHeight
            End With
            
            ' Gre fr das D2D1SvgDocument Interface
            With tSIZEF
                .Width = CSng(Me.ScaleWidth)
                .Height = CSng(Me.ScaleHeight)
            End With
            
            ptSIZEU = VarPtr(tSIZEU)
            
            ' Resize des D2D1HwndRenderTarget
            If Invoke(pRenderTarget, Resize, ptSIZEU) = S_OK Then
            
                ' mit dem zeichnen auf dem D2D1HwndRenderTarget beginnen
                Call Invoke(pRenderTarget, BeginDraw)
                
                ' Farbe festlegen
                ptCOLORF = VarPtr(COLOR_F_LONGA(vbWhite, 1))
                
                ' Inhalt des D2D1HwndRenderTarget lschen bzw.
                ' mit einer Farbe berzeichnen
                Call Invoke(pRenderTarget, Clear, ptCOLORF)
                
                ppDeviceContext5 = VarPtr(pDeviceContext5)
                ptGUID = VarPtr(Str2Guid(IID_ID2D1DeviceContext5))
                
                ' ein D2D1DeviceContext5 Interface erstellen
                If Invoke(pRenderTarget, QueryInterface, ptGUID, ppDeviceContext5) = S_OK Then
                    
                    ' ein WICImagingFactory Interface erstellen
                    If InitInterface(pWicFactory, CLSID_WICImagingFactory1, _
                        IID_IWICImagingFactory) = True Then
                        
                        ppWICStream = VarPtr(pWICStream)
                        
                        ' ein WICStream Interface erstellen
                        If Invoke(pWicFactory, CreateStream, ppWICStream) = S_OK Then
                            
                            psFileName = StrPtr(sFileName)
                            
                            ' SVG in den WICStream laden
                            If Invoke(pWICStream, InitializeFromFilename, _
                                psFileName, GENERIC_READ) = S_OK Then
                                
                                ppSvgDocument = VarPtr(pSvgDocument)
                                
                                ' HRESULT CreateSvgDocument(
                                '  IStream          *inputXmlStream,
                                '  D2D1_SIZE_F      viewportSize,
                                '  ID2D1SvgDocument **svgDocument
                                ' );
                                '
                                ' Ja ich weis. Nachfolgender Aufruf ist nicht richtig.
                                ' ByVal D2D1_SIZE_F!!! Kann VB6 ja blderwise nicht. ;-)
                                '
                                ' ein D2D1SvgDocument Interface aus dem WICStream erstellen
                                If Invoke(pDeviceContext5, CreateSvgDocument, pWICStream, tSIZEF.Width, _
                                    tSIZEF.Height, ppSvgDocument) = S_OK Then
                                    
                                    ' D2D1SvgDocument in den D2D1HwndRenderTarget zeichnen
                                    Call Invoke(pDeviceContext5, DrawSvgDocument, pSvgDocument)
                                        
                                    ' hat dann ja wohl funktioniert ;-)
                                    Debug.Print "SVG wurde auf die Form gerendert."
                                    
                                    ' Aufrumen
                                    Call Release(pSvgDocument)
                                    
                                End If
                            End If
                            
                            ' Aufrumen
                            Call Release(pWICStream)
                            
                        End If
                        
                        ' Aufrumen
                        Call Release(pWicFactory)
                        
                    End If
                    
                    ' Aufrumen
                    Call Release(pDeviceContext5)
                    
                End If
                
                ' das zeichnen auf das D2D1HwndRenderTarget beenden
                Call Invoke(pRenderTarget, EndDraw, 0&, 0&)
                
            End If
            
            ' Aufrumen
            Call Release(pRenderTarget)
            
        End If
        
        ' Aufrumen
        Call Release(pD2D1Factory)
        
    End If
    
End Sub

' SVG in ein PNG (Datei) konvertieren
Private Sub Command2_Click()

    Dim ptRTP As Long
    Dim ptGUID As Long
    Dim pWICStream As Long
    Dim pWICBitmap As Long
    Dim pWicFactory As Long
    Dim ppWICStream As Long
    Dim ppWICBitmap As Long
    Dim pD2D1Factory As Long
    Dim pSvgDocument As Long
    Dim pFrameEncode As Long
    Dim ppSvgDocument As Long
    Dim pRenderTarget As Long
    Dim ppFrameEncode As Long
    Dim psSVGFileName As Long
    Dim psPNGFileName As Long
    Dim ppRenderTarget As Long
    Dim pDeviceContext5 As Long
    Dim ppDeviceContext5 As Long
    Dim pWICBitmapEncoder As Long
    Dim ppWICBitmapEncoder As Long
    Dim sSVGFileName As String
    Dim sPNGFileName As String
    Dim tRTP As D2D1_RENDER_TARGET_PROPERTIES
    
    ' Pfad zur SVG
    sSVGFileName = App.Path & "\tiger.svg"
    
    ' Pfad zur PNG
    sPNGFileName = App.Path & "\tiger.png"
    
    ' ein WICImagingFactory Interface erstellen
    If InitInterface(pWicFactory, CLSID_WICImagingFactory1, _
        IID_IWICImagingFactory) = True Then
        
        ppWICBitmap = VarPtr(pWICBitmap)
        ptGUID = VarPtr(Str2Guid(GUID_WICPixelFormat32bppPBGRA))
        
        ' ein WICBitmap Interface erstellen
        If Invoke(pWicFactory, CreateBitmap, 800, 800, ptGUID, _
            WICBitmapCacheOnDemand, ppWICBitmap) = S_OK Then
            
            ppWICStream = VarPtr(pWICStream)
            
            ' ein WICStream Interface erstellen
            If Invoke(pWicFactory, CreateStream, ppWICStream) = S_OK Then
            
                psSVGFileName = StrPtr(sSVGFileName)
                
                ' SVG in den WICStream laden
                If Invoke(pWICStream, InitializeFromFilename, psSVGFileName, _
                    GENERIC_READ) = S_OK Then
                    
                    ptGUID = VarPtr(Str2Guid(IID_ID2D1Factory))
                    
                    ' ein D2D1Factory Interface erstellen
                    If D2D1CreateFactory(0&, ptGUID, 0&, pD2D1Factory) = S_OK Then
                    
                        ' Pixelformat und Alphamode fr den RenderTarget festlegen
                        With tRTP
                            .PixelFormat.dFormat = DXGI_FORMAT_B8G8R8A8_UNORM
                            .PixelFormat.alphaMode = D2D1_ALPHA_MODE_PREMULTIPLIED
                        End With
                        
                        ptRTP = VarPtr(tRTP)
                        ppRenderTarget = VarPtr(pRenderTarget)
                        
                        ' ein D2D1RenderTarget Interface erstellen
                        If Invoke(pD2D1Factory, CreateWicBitmapRenderTarget, pWICBitmap, _
                            ptRTP, ppRenderTarget) = S_OK Then
                            
                            ' mit dem zeichnen auf dem D2D1RenderTarget beginnen
                            Call Invoke(pRenderTarget, BeginDraw)
                            
                            ppDeviceContext5 = VarPtr(pDeviceContext5)
                            ptGUID = VarPtr(Str2Guid(IID_ID2D1DeviceContext5))
                            
                            ' ein D2D1DeviceContext5 Interface erstellen
                            If Invoke(pRenderTarget, QueryInterface, ptGUID, _
                                ppDeviceContext5) = S_OK Then
                                
                                ppSvgDocument = VarPtr(pSvgDocument)
                                
                                ' HRESULT CreateSvgDocument(
                                '  IStream          *inputXmlStream,
                                '  D2D1_SIZE_F      viewportSize,
                                '  ID2D1SvgDocument **svgDocument
                                ' );
                                '
                                ' Ja ich weis. Nachfolgender Aufruf ist nicht richtig.
                                ' ByVal D2D1_SIZE_F!!! Kann VB6 ja blderwise nicht. ;-)
                                '
                                ' ein D2D1SvgDocument Interface aus dem WICStream erstellen
                                If Invoke(pDeviceContext5, CreateSvgDocument, pWICStream, _
                                    CSng(800), CSng(800), ppSvgDocument) = S_OK Then
                                    
                                    ' D2D1SvgDocument in den D2D1RenderTarget zeichnen
                                    Call Invoke(pDeviceContext5, DrawSvgDocument, pSvgDocument)
                                        
                                    ' Aufrumen
                                    Call Release(pSvgDocument)
                                    
                                End If
                                
                                ' Aufrumen
                                Call Release(pDeviceContext5)
                                
                            End If
                            
                            ' das zeichnen auf das D2D1RenderTarget beenden
                            Call Invoke(pRenderTarget, EndDraw, 0&, 0&)
                            
                            ' Aufrumen
                            Call Release(pRenderTarget)
                            
                        End If
                        
                        ' Aufrumen
                        Call Release(pD2D1Factory)
                        
                    End If
                End If
                
                ' Aufrumen
                Call Release(pWICStream)
                
            End If
            
            ' ein WICStream Interface erstellen
            If Invoke(pWicFactory, CreateStream, ppWICStream) = S_OK Then
            
                psPNGFileName = StrPtr(sPNGFileName)
                
                ' PNG-Datei erstellen -> WICStream
                If Invoke(pWICStream, InitializeFromFilename, psPNGFileName, _
                    GENERIC_WRITE) = S_OK Then
                    
                    ptGUID = VarPtr(Str2Guid(GUID_ContainerFormatPng))
                    ppWICBitmapEncoder = VarPtr(pWICBitmapEncoder)
                    
                    ' ein PNG WICBitmapEncoder Interface erstellen
                    If Invoke(pWicFactory, CreateEncoder, ptGUID, 0&, _
                        ppWICBitmapEncoder) = S_OK Then
                        
                        ' WICBitmapEncoder vom WICStream initialisieren
                        If Invoke(pWICBitmapEncoder, Initialize, pWICStream, _
                            WICBitmapEncoderNoCache) = S_OK Then
                            
                            ppFrameEncode = VarPtr(pFrameEncode)
                            
                            ' ein WICBitmapFrameEncode Interface erstellen
                            If Invoke(pWICBitmapEncoder, CreateNewFrame, _
                                ppFrameEncode, 0&) = S_OK Then
                                
                                ' WICBitmapFrameEncode initialisieren
                                If Invoke(pFrameEncode, Initialize, 0&) = S_OK Then
                                
                                    ' Gre festlegen
                                    If Invoke(pFrameEncode, SetSize, 800, 800) = S_OK Then
                                        
                                        ptGUID = VarPtr(Str2Guid(GUID_WICPixelFormat32bppPBGRA))
                                            
                                        ' Pixeformat festlegen
                                        If Invoke(pFrameEncode, SetPixelFormat, ptGUID) = S_OK Then
                                            
                                            ' WICBitmap in den WICBitmapFrameEncode schreiben
                                            If Invoke(pFrameEncode, WriteSource, pWICBitmap, 0&) = S_OK Then
                                                
                                                ' WICBitmapFrameEncode schreiben abschlieen
                                                If Invoke(pFrameEncode, Commit_Frame) = S_OK Then
                                                    
                                                    'Debug.Print "OK"
                                                    
                                                End If
                                            End If
                                        End If
                                    End If
                                End If
                                
                                ' Aufrumen
                                Call Release(pFrameEncode)
                                
                            End If
                        End If
                        
                        ' WICBitmapEncoder schreiben beenden
                        If Invoke(pWICBitmapEncoder, Commit_Encoder) = S_OK Then
                        
                            Debug.Print "SVG wurde zu PNG-Datei konvertiert."
                            
                        End If
                        
                        ' Aufrumen
                        Call Release(pWICBitmapEncoder)
                        
                    End If
                End If
                
                ' Aufrumen
                Call Release(pWICStream)
                
            End If
            
            ' Aufrumen
            Call Release(pWICBitmap)
            
        End If
        
        ' Aufrumen
        Call Release(pWicFactory)
        
    End If
    
End Sub

' SVG -> IWICBitmap -> IStream (PNG) -> GDI+ Bitmap
Private Sub Command3_Click()

    Dim ptRTP As Long
    Dim ptGUID As Long
    Dim pPngStream As Long
    Dim pWICStream As Long
    Dim pWICBitmap As Long
    Dim pWicFactory As Long
    Dim ppWICStream As Long
    Dim ppWICBitmap As Long
    Dim pD2D1Factory As Long
    Dim pSvgDocument As Long
    Dim pFrameEncode As Long
    Dim ppSvgDocument As Long
    Dim pRenderTarget As Long
    Dim ppFrameEncode As Long
    Dim psSVGFileName As Long
    Dim ppRenderTarget As Long
    Dim pDeviceContext5 As Long
    Dim ppDeviceContext5 As Long
    Dim pWICBitmapEncoder As Long
    Dim ppWICBitmapEncoder As Long
    Dim sSVGFileName As String
    Dim tRTP As D2D1_RENDER_TARGET_PROPERTIES
    
    ' Pfad zur SVG
    sSVGFileName = App.Path & "\tiger.svg"
    
    ' ein WICImagingFactory Interface erstellen
    If InitInterface(pWicFactory, CLSID_WICImagingFactory1, _
        IID_IWICImagingFactory) = True Then
        
        ppWICBitmap = VarPtr(pWICBitmap)
        ptGUID = VarPtr(Str2Guid(GUID_WICPixelFormat32bppPBGRA))
        
        ' ein WICBitmap Interface erstellen
        If Invoke(pWicFactory, CreateBitmap, 800, 800, ptGUID, _
            WICBitmapCacheOnDemand, ppWICBitmap) = S_OK Then
            
            ppWICStream = VarPtr(pWICStream)
            
            ' ein WICStream Interface erstellen
            If Invoke(pWicFactory, CreateStream, ppWICStream) = S_OK Then
            
                psSVGFileName = StrPtr(sSVGFileName)
                
                ' SVG in den WICStream laden
                If Invoke(pWICStream, InitializeFromFilename, psSVGFileName, _
                    GENERIC_READ) = S_OK Then
                    
                    ptGUID = VarPtr(Str2Guid(IID_ID2D1Factory))
                    
                    ' ein D2D1Factory Interface erstellen
                    If D2D1CreateFactory(0&, ptGUID, 0&, pD2D1Factory) = S_OK Then
                    
                        ' Pixelformat und Alphamode fr den RenderTarget festlegen
                        With tRTP
                            .PixelFormat.dFormat = DXGI_FORMAT_B8G8R8A8_UNORM
                            .PixelFormat.alphaMode = D2D1_ALPHA_MODE_PREMULTIPLIED
                        End With
                        
                        ptRTP = VarPtr(tRTP)
                        ppRenderTarget = VarPtr(pRenderTarget)
                        
                        ' ein D2D1RenderTarget Interface erstellen
                        If Invoke(pD2D1Factory, CreateWicBitmapRenderTarget, pWICBitmap, _
                            ptRTP, ppRenderTarget) = S_OK Then
                            
                            ' mit dem zeichnen auf dem D2D1RenderTarget beginnen
                            Call Invoke(pRenderTarget, BeginDraw)
                            
                            ppDeviceContext5 = VarPtr(pDeviceContext5)
                            ptGUID = VarPtr(Str2Guid(IID_ID2D1DeviceContext5))
                            
                            ' ein D2D1DeviceContext5 Interface erstellen
                            If Invoke(pRenderTarget, QueryInterface, ptGUID, _
                                ppDeviceContext5) = S_OK Then
                                
                                ppSvgDocument = VarPtr(pSvgDocument)
                                
                                ' HRESULT CreateSvgDocument(
                                '  IStream          *inputXmlStream,
                                '  D2D1_SIZE_F      viewportSize,
                                '  ID2D1SvgDocument **svgDocument
                                ' );
                                '
                                ' Ja ich weis. Nachfolgender Aufruf ist nicht richtig.
                                ' ByVal D2D1_SIZE_F!!! Kann VB6 ja blderwise nicht. ;-)
                                '
                                ' ein D2D1SvgDocument Interface aus dem WICStream erstellen
                                If Invoke(pDeviceContext5, CreateSvgDocument, pWICStream, _
                                    CSng(800), CSng(800), ppSvgDocument) = S_OK Then
                                    
                                    ' D2D1SvgDocument in den D2D1RenderTarget zeichnen
                                    Call Invoke(pDeviceContext5, DrawSvgDocument, pSvgDocument)
                                        
                                    ' Aufrumen
                                    Call Release(pSvgDocument)
                                    
                                End If
                                
                                ' Aufrumen
                                Call Release(pDeviceContext5)
                                
                            End If
                            
                            ' das zeichnen auf das D2D1RenderTarget beenden
                            Call Invoke(pRenderTarget, EndDraw, 0&, 0&)
                            
                            ' Aufrumen
                            Call Release(pRenderTarget)
                            
                        End If
                        
                        ' Aufrumen
                        Call Release(pD2D1Factory)
                        
                    End If
                End If
                
                ' Aufrumen
                Call Release(pWICStream)
                
            End If
            
            ' IStream Interface erstellen
            pPngStream = SHCreateMemStream(0&, 0&)
            
            If pPngStream <> 0& Then
            
                ppWICStream = VarPtr(pWICStream)
            
                ' ein WICStream Interface erstellen
                If Invoke(pWicFactory, CreateStream, ppWICStream) = S_OK Then
            
                    ' IStream -> WICStream
                    If Invoke(pWICStream, InitializeFromIStream, pPngStream) = S_OK Then
                    
                        ptGUID = VarPtr(Str2Guid(GUID_ContainerFormatPng))
                        ppWICBitmapEncoder = VarPtr(pWICBitmapEncoder)
                    
                        ' ein PNG WICBitmapEncoder Interface erstellen
                        If Invoke(pWicFactory, CreateEncoder, ptGUID, 0&, _
                            ppWICBitmapEncoder) = S_OK Then
                        
                            ' WICBitmapEncoder vom WICStream initialisieren
                            If Invoke(pWICBitmapEncoder, Initialize, pWICStream, _
                                WICBitmapEncoderNoCache) = S_OK Then
                            
                                ppFrameEncode = VarPtr(pFrameEncode)
                            
                                ' ein WICBitmapFrameEncode Interface erstellen
                                If Invoke(pWICBitmapEncoder, CreateNewFrame, _
                                    ppFrameEncode, 0&) = S_OK Then
                                
                                    ' WICBitmapFrameEncode initialisieren
                                    If Invoke(pFrameEncode, Initialize, 0&) = S_OK Then
                                
                                        ' Gre festlegen
                                        If Invoke(pFrameEncode, SetSize, 800, 800) = S_OK Then
                                        
                                            ptGUID = VarPtr(Str2Guid(GUID_WICPixelFormat32bppPBGRA))
                                            
                                            ' Pixeformat festlegen
                                            If Invoke(pFrameEncode, SetPixelFormat, ptGUID) = S_OK Then
                                            
                                                ' WICBitmap in den WICBitmapFrameEncode schreiben
                                                If Invoke(pFrameEncode, WriteSource, pWICBitmap, 0&) = S_OK Then
                                                
                                                    ' WICBitmapFrameEncode schreiben abschlieen
                                                    If Invoke(pFrameEncode, Commit_Frame) = S_OK Then
                                                    
                                                        'Debug.Print "OK"
                                                    
                                                    End If
                                                End If
                                            End If
                                        End If
                                    End If
                                
                                    ' Aufrumen
                                    Call Release(pFrameEncode)
                                
                                End If
                            End If
                        
                            ' WICBitmapEncoder schreiben beenden
                            If Invoke(pWICBitmapEncoder, Commit_Encoder) = S_OK Then
                        
                                'Debug.Print "WICBitmap saved as a png in an IStream."
                            
                            End If
                        
                            ' Aufrumen
                            Call Release(pWICBitmapEncoder)
                        
                        End If
                    End If
                
                    ' Aufrumen
                    Call Release(pWICStream)
                
                End If
            
                ' Aufrumen
                Call Release(pWICBitmap)
            
            End If
                
            ' ----==== GDI+ ====----
            Dim lGdipImage As Long
            
            If GdipLoadImageFromStream(pPngStream, lGdipImage) = OK Then
            
                Debug.Print "GDI+ Bitmap erstellt. IStream -> GDI+ Bitmap"
            
                ' Aufrumen
                Call GdipDisposeImage(lGdipImage)
                
            End If
            ' ----==== GDI+ ====----
            
            ' Aufrumen
            Call Release(pPngStream)
            
        End If
        
        ' Aufrumen
        Call Release(pWicFactory)
        
    End If

End Sub

' SVG -> WICBitmap -> ByteArray -> GDI+ Bitmap
Private Sub Command4_Click()

    Dim ptRTP As Long
    Dim ptGUID As Long
    Dim pbData As Long
    Dim lStride As Long
    Dim lBuffSize As Long
    Dim ptWICRect As Long
    Dim pWICStream As Long
    Dim pWICBitmap As Long
    Dim pWicFactory As Long
    Dim ppWICStream As Long
    Dim ppWICBitmap As Long
    Dim pD2D1Factory As Long
    Dim pSvgDocument As Long
    Dim ppSvgDocument As Long
    Dim pRenderTarget As Long
    Dim psSVGFileName As Long
    Dim ppRenderTarget As Long
    Dim pDeviceContext5 As Long
    Dim ppDeviceContext5 As Long
    Dim sSVGFileName As String
    Dim bData() As Byte
    Dim tWICRect As WICRect
    Dim tRTP As D2D1_RENDER_TARGET_PROPERTIES
    
    ' Pfad zur SVG
    sSVGFileName = App.Path & "\tiger.svg"
    
    ' ein WICImagingFactory Interface erstellen
    If InitInterface(pWicFactory, CLSID_WICImagingFactory1, _
        IID_IWICImagingFactory) = True Then
        
        ppWICBitmap = VarPtr(pWICBitmap)
        ptGUID = VarPtr(Str2Guid(GUID_WICPixelFormat32bppPBGRA))
        
        ' ein WICBitmap Interface erstellen
        If Invoke(pWicFactory, CreateBitmap, 800, 800, ptGUID, _
            WICBitmapCacheOnDemand, ppWICBitmap) = S_OK Then
            
            ppWICStream = VarPtr(pWICStream)
            
            ' ein WICStream Interface erstellen
            If Invoke(pWicFactory, CreateStream, ppWICStream) = S_OK Then
            
                psSVGFileName = StrPtr(sSVGFileName)
                
                ' SVG in den WICStream laden
                If Invoke(pWICStream, InitializeFromFilename, psSVGFileName, _
                    GENERIC_READ) = S_OK Then
                    
                    ptGUID = VarPtr(Str2Guid(IID_ID2D1Factory))
                    
                    ' ein D2D1Factory Interface erstellen
                    If D2D1CreateFactory(0&, ptGUID, 0&, pD2D1Factory) = S_OK Then
                    
                        ' Pixelformat und Alphamode fr den RenderTarget festlegen
                        With tRTP
                            .PixelFormat.dFormat = DXGI_FORMAT_B8G8R8A8_UNORM
                            .PixelFormat.alphaMode = D2D1_ALPHA_MODE_PREMULTIPLIED
                        End With
                        
                        ptRTP = VarPtr(tRTP)
                        ppRenderTarget = VarPtr(pRenderTarget)
                        
                        ' ein D2D1RenderTarget Interface erstellen
                        If Invoke(pD2D1Factory, CreateWicBitmapRenderTarget, pWICBitmap, _
                            ptRTP, ppRenderTarget) = S_OK Then
                            
                            ' mit dem zeichnen auf dem D2D1RenderTarget beginnen
                            Call Invoke(pRenderTarget, BeginDraw)
                            
                            ppDeviceContext5 = VarPtr(pDeviceContext5)
                            ptGUID = VarPtr(Str2Guid(IID_ID2D1DeviceContext5))
                            
                            ' ein D2D1DeviceContext5 Interface erstellen
                            If Invoke(pRenderTarget, QueryInterface, ptGUID, _
                                ppDeviceContext5) = S_OK Then
                                
                                ppSvgDocument = VarPtr(pSvgDocument)
                                
                                ' HRESULT CreateSvgDocument(
                                '  IStream          *inputXmlStream,
                                '  D2D1_SIZE_F      viewportSize,
                                '  ID2D1SvgDocument **svgDocument
                                ' );
                                '
                                ' Ja ich weis. Nachfolgender Aufruf ist nicht richtig.
                                ' ByVal D2D1_SIZE_F!!! Kann VB6 ja blderwise nicht. ;-)
                                '
                                ' ein D2D1SvgDocument Interface aus dem WICStream erstellen
                                If Invoke(pDeviceContext5, CreateSvgDocument, pWICStream, _
                                    CSng(800), CSng(800), ppSvgDocument) = S_OK Then
                                    
                                    ' D2D1SvgDocument in den D2D1RenderTarget zeichnen
                                    Call Invoke(pDeviceContext5, DrawSvgDocument, pSvgDocument)
                                        
                                    ' Aufrumen
                                    Call Release(pSvgDocument)
                                    
                                End If
                                
                                ' Aufrumen
                                Call Release(pDeviceContext5)
                                
                            End If
                            
                            ' das zeichnen auf das D2D1RenderTarget beenden
                            Call Invoke(pRenderTarget, EndDraw, 0&, 0&)
                            
                            ' Aufrumen
                            Call Release(pRenderTarget)
                            
                        End If
                        
                        ' Aufrumen
                        Call Release(pD2D1Factory)
                        
                    End If
                End If
                
                ' Aufrumen
                Call Release(pWICStream)
                
            End If
            
            With tWICRect
                .x = 0
                .y = 0
                .Width = 800
                .Height = 800
            End With
            
            lStride = tWICRect.Width * 4 ' 32bppARGB!!!
            lBuffSize = tWICRect.Height * lStride
            ReDim bData(lBuffSize - 1)
            
            ptWICRect = VarPtr(tWICRect)
            pbData = VarPtr(bData(0))
            
            ' WICBitmap -> ByteArray
            If Invoke(pWICBitmap, CopyPixels, ptWICRect, lStride, lBuffSize, pbData) = S_OK Then
            
                ' ----==== GDI+ ====----
                Dim lGdipImage As Long
            
                ' ByteArray -> GDI+ Bitmap
                If GdipCreateBitmapFromScan0(tWICRect.Width, tWICRect.Height, lStride, _
                    PixelFormat32bppARGB, pbData, lGdipImage) = OK Then
                
                    Debug.Print "GDI+ Bitmap erstellt. ByteArray -> GDI+ Bitmap"
            
                    ' Aufrumen
                    Call GdipDisposeImage(lGdipImage)
                    
                End If
                ' ----==== GDI+ ====----
            
            End If
            
            ' Aufrumen
            Call Release(pWICBitmap)
            
        End If
        
        ' Aufrumen
        Call Release(pWicFactory)
        
    End If

End Sub

' SVG -> WICBitmap -> GDI+ Bitmap (LockBits)
Private Sub Command5_Click()

    Dim ptRTP As Long
    Dim ptGUID As Long
    Dim pScan0 As Long
    Dim ppScan0 As Long
    Dim lStride As Long
    Dim plStride As Long
    Dim lBuffSize As Long
    Dim plBuffSize As Long
    Dim ptWICRect As Long
    Dim pWICStream As Long
    Dim pWICBitmap As Long
    Dim pWicFactory As Long
    Dim ppWICStream As Long
    Dim ppWICBitmap As Long
    Dim pD2D1Factory As Long
    Dim pSvgDocument As Long
    Dim ppSvgDocument As Long
    Dim pRenderTarget As Long
    Dim psSVGFileName As Long
    Dim ppRenderTarget As Long
    Dim pWICBitmapLock As Long
    Dim ppWICBitmapLock As Long
    Dim pDeviceContext5 As Long
    Dim ppDeviceContext5 As Long
    Dim sSVGFileName As String
    Dim tWICRect As WICRect
    Dim tRTP As D2D1_RENDER_TARGET_PROPERTIES
    
    ' Pfad zur SVG
    sSVGFileName = App.Path & "\tiger.svg"
    
    ' ein WICImagingFactory Interface erstellen
    If InitInterface(pWicFactory, CLSID_WICImagingFactory1, _
        IID_IWICImagingFactory) = True Then
        
        ppWICBitmap = VarPtr(pWICBitmap)
        ptGUID = VarPtr(Str2Guid(GUID_WICPixelFormat32bppPBGRA))
        
        ' ein WICBitmap Interface erstellen
        If Invoke(pWicFactory, CreateBitmap, 800, 800, ptGUID, _
            WICBitmapCacheOnDemand, ppWICBitmap) = S_OK Then
            
            ppWICStream = VarPtr(pWICStream)
            
            ' ein WICStream Interface erstellen
            If Invoke(pWicFactory, CreateStream, ppWICStream) = S_OK Then
            
                psSVGFileName = StrPtr(sSVGFileName)
                
                ' SVG in den WICStream laden
                If Invoke(pWICStream, InitializeFromFilename, psSVGFileName, _
                    GENERIC_READ) = S_OK Then
                    
                    ptGUID = VarPtr(Str2Guid(IID_ID2D1Factory))
                    
                    ' ein D2D1Factory Interface erstellen
                    If D2D1CreateFactory(0&, ptGUID, 0&, pD2D1Factory) = S_OK Then
                    
                        ' Pixelformat und Alphamode fr den RenderTarget festlegen
                        With tRTP
                            .PixelFormat.dFormat = DXGI_FORMAT_B8G8R8A8_UNORM
                            .PixelFormat.alphaMode = D2D1_ALPHA_MODE_PREMULTIPLIED
                        End With
                        
                        ptRTP = VarPtr(tRTP)
                        ppRenderTarget = VarPtr(pRenderTarget)
                        
                        ' ein D2D1RenderTarget Interface erstellen
                        If Invoke(pD2D1Factory, CreateWicBitmapRenderTarget, pWICBitmap, _
                            ptRTP, ppRenderTarget) = S_OK Then
                            
                            ' mit dem zeichnen auf dem D2D1RenderTarget beginnen
                            Call Invoke(pRenderTarget, BeginDraw)
                            
                            ppDeviceContext5 = VarPtr(pDeviceContext5)
                            ptGUID = VarPtr(Str2Guid(IID_ID2D1DeviceContext5))
                            
                            ' ein D2D1DeviceContext5 Interface erstellen
                            If Invoke(pRenderTarget, QueryInterface, ptGUID, _
                                ppDeviceContext5) = S_OK Then
                                
                                ppSvgDocument = VarPtr(pSvgDocument)
                                
                                ' HRESULT CreateSvgDocument(
                                '  IStream          *inputXmlStream,
                                '  D2D1_SIZE_F      viewportSize,
                                '  ID2D1SvgDocument **svgDocument
                                ' );
                                '
                                ' Ja ich weis. Nachfolgender Aufruf ist nicht richtig.
                                ' ByVal D2D1_SIZE_F!!! Kann VB6 ja blderwise nicht. ;-)
                                '
                                ' ein D2D1SvgDocument Interface aus dem WICStream erstellen
                                If Invoke(pDeviceContext5, CreateSvgDocument, pWICStream, _
                                    CSng(800), CSng(800), ppSvgDocument) = S_OK Then
                                    
                                    ' D2D1SvgDocument in den D2D1RenderTarget zeichnen
                                    Call Invoke(pDeviceContext5, DrawSvgDocument, pSvgDocument)
                                        
                                    ' Aufrumen
                                    Call Release(pSvgDocument)
                                    
                                End If
                                
                                ' Aufrumen
                                Call Release(pDeviceContext5)
                                
                            End If
                            
                            ' das zeichnen auf das D2D1RenderTarget beenden
                            Call Invoke(pRenderTarget, EndDraw, 0&, 0&)
                            
                            ' Aufrumen
                            Call Release(pRenderTarget)
                            
                        End If
                        
                        ' Aufrumen
                        Call Release(pD2D1Factory)
                        
                    End If
                End If
                
                ' Aufrumen
                Call Release(pWICStream)
                
            End If
            
            With tWICRect
                .x = 0
                .y = 0
                .Width = 800
                .Height = 800
            End With
            
            ptWICRect = VarPtr(tWICRect)
            ppWICBitmapLock = VarPtr(pWICBitmapLock)
            
            ' WICBitmap -> WICBitmapLock
            If Invoke(pWICBitmap, Lock_Bits, ptWICRect, WICBitmapLockRead, ppWICBitmapLock) = S_OK Then
            
                plStride = VarPtr(lStride)
                
                ' Stride ermitteln
                If Invoke(pWICBitmapLock, GetStride, plStride) = S_OK Then
                
                    ppScan0 = VarPtr(pScan0)
                    plBuffSize = VarPtr(lBuffSize)
                
                    ' Gre des Puffers und Pointer auf die Pixeldaten ermitteln
                    If Invoke(pWICBitmapLock, GetDataPointer, plBuffSize, ppScan0) = S_OK Then
                    
                        ' ----==== GDI+ ====----
                        Dim lGdipImage As Long
            
                        ' Direkt pScan0 -> GDI+ Bitmap
                        If GdipCreateBitmapFromScan0(tWICRect.Width, tWICRect.Height, lStride, _
                            PixelFormat32bppARGB, pScan0, lGdipImage) = OK Then
                
                            Debug.Print "GDI+ Bitmap erstellt. Direkt pScan0 -> GDI+ Bitmap"
            
                            ' Aufrumen
                            Call GdipDisposeImage(lGdipImage)
                    
                        End If
                        
                        ' oder per CopyMemory pScan0 -> tBitmapData.Scan0
                        
                        Dim tRECTL As RECTL
                        Dim tBitmapData As BitmapData
                        
                        With tRECTL
                            .Left = 0
                            .Top = 0
                            .Width = 800
                            .Height = 800
                        End With
                        
                        ' GDI+ Bitmap erstellen
                        If GdipCreateBitmapFromScan0(tRECTL.Width, tRECTL.Height, 0&, _
                            PixelFormat32bppARGB, 0&, lGdipImage) = OK Then
                            
                            ' LockBits
                            If GdipBitmapLockBits(lGdipImage, tRECTL, ImageLockModeWrite, _
                                PixelFormat32bppARGB, tBitmapData) = OK Then
                            
                                ' Copy Pixels from pScan0 (WICBitmapLock) to tBitmapData.Scan0 (GDI+ Bitmap)
                                Call CopyMemory(ByVal tBitmapData.Scan0, ByVal pScan0, lBuffSize)
                                
                                Debug.Print "GDI+ Bitmap erstellt. CopyMemory pScan0 -> tBitmapData.Scan0"
                            
                                Call GdipBitmapUnlockBits(lGdipImage, tBitmapData)
                            End If
            
                            ' Aufrumen
                            Call GdipDisposeImage(lGdipImage)
                    
                        End If
                        ' ----==== GDI+ ====----
                    
                    End If
                    
                End If
                
                ' Aufrumen
                Call Release(pWICBitmapLock)
            
            End If
            
            ' Aufrumen
            Call Release(pWICBitmap)
            
        End If
        
        ' Aufrumen
        Call Release(pWicFactory)
        
    End If

End Sub

Private Function Invoke(ByVal pInterface As Long, ByVal vtb As vtb_Interfaces, _
    ParamArray var()) As Variant
    
    If pInterface <> 0& Then
    
        Invoke = modInterface.OleInvoke(pInterface, vtb, var)
        
    End If
    
End Function

Private Sub Release(ByRef pInterface As Long)

    If pInterface <> 0& Then
    
        Call modInterface.ReleaseInterface(pInterface)
        
    End If
    
End Sub

Private Function Str2Guid(ByVal str As String) As GUID

    Dim pstr As Long
    
    pstr = StrPtr(str)
    
    Call CLSIDFromString(pstr, Str2Guid)
    
End Function

Private Function COLOR_F_LONGA(ByVal lColor As Long, Optional ByVal a As Single = 1!) _
    As D2D1_COLOR_F
    
    Dim lRetColor As Long
    Dim tRGBA As RGBA
    
    Call OleTranslateColor(lColor, 0&, lRetColor)
    Call CopyMemory(tRGBA, lRetColor, 4)
    
    With COLOR_F_LONGA
    
        .a = a
        .r = CSng(tRGBA.r) / 255!
        .g = CSng(tRGBA.g) / 255!
        .b = CSng(tRGBA.b) / 255!
        
    End With
    
End Function

